/**
 * Autogenerated by Thrift Compiler (0.13.0)
 *
 * DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
 *  @generated
 */
package org.eclipse.hawk.service.api;

@SuppressWarnings({"cast", "rawtypes", "serial", "unchecked", "unused"})
@javax.annotation.Generated(value = "Autogenerated by Thrift Compiler (0.13.0)", date = "2021-04-18")
public class HawkSynchronizationStartEvent implements org.apache.thrift.TBase<HawkSynchronizationStartEvent, HawkSynchronizationStartEvent._Fields>, java.io.Serializable, Cloneable, Comparable<HawkSynchronizationStartEvent> {
  private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("HawkSynchronizationStartEvent");

  private static final org.apache.thrift.protocol.TField TIMESTAMP_NANOS_FIELD_DESC = new org.apache.thrift.protocol.TField("timestampNanos", org.apache.thrift.protocol.TType.I64, (short)1);

  private static final org.apache.thrift.scheme.SchemeFactory STANDARD_SCHEME_FACTORY = new HawkSynchronizationStartEventStandardSchemeFactory();
  private static final org.apache.thrift.scheme.SchemeFactory TUPLE_SCHEME_FACTORY = new HawkSynchronizationStartEventTupleSchemeFactory();

  public long timestampNanos; // required

  /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
  public enum _Fields implements org.apache.thrift.TFieldIdEnum {
    TIMESTAMP_NANOS((short)1, "timestampNanos");

    private static final java.util.Map<java.lang.String, _Fields> byName = new java.util.HashMap<java.lang.String, _Fields>();

    static {
      for (_Fields field : java.util.EnumSet.allOf(_Fields.class)) {
        byName.put(field.getFieldName(), field);
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, or null if its not found.
     */
    @org.apache.thrift.annotation.Nullable
    public static _Fields findByThriftId(int fieldId) {
      switch(fieldId) {
        case 1: // TIMESTAMP_NANOS
          return TIMESTAMP_NANOS;
        default:
          return null;
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, throwing an exception
     * if it is not found.
     */
    public static _Fields findByThriftIdOrThrow(int fieldId) {
      _Fields fields = findByThriftId(fieldId);
      if (fields == null) throw new java.lang.IllegalArgumentException("Field " + fieldId + " doesn't exist!");
      return fields;
    }

    /**
     * Find the _Fields constant that matches name, or null if its not found.
     */
    @org.apache.thrift.annotation.Nullable
    public static _Fields findByName(java.lang.String name) {
      return byName.get(name);
    }

    private final short _thriftId;
    private final java.lang.String _fieldName;

    _Fields(short thriftId, java.lang.String fieldName) {
      _thriftId = thriftId;
      _fieldName = fieldName;
    }

    public short getThriftFieldId() {
      return _thriftId;
    }

    public java.lang.String getFieldName() {
      return _fieldName;
    }
  }

  // isset id assignments
  private static final int __TIMESTAMPNANOS_ISSET_ID = 0;
  private byte __isset_bitfield = 0;
  public static final java.util.Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
  static {
    java.util.Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new java.util.EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
    tmpMap.put(_Fields.TIMESTAMP_NANOS, new org.apache.thrift.meta_data.FieldMetaData("timestampNanos", org.apache.thrift.TFieldRequirementType.REQUIRED, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.I64)));
    metaDataMap = java.util.Collections.unmodifiableMap(tmpMap);
    org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(HawkSynchronizationStartEvent.class, metaDataMap);
  }

  public HawkSynchronizationStartEvent() {
  }

  public HawkSynchronizationStartEvent(
    long timestampNanos)
  {
    this();
    this.timestampNanos = timestampNanos;
    setTimestampNanosIsSet(true);
  }

  /**
   * Performs a deep copy on <i>other</i>.
   */
  public HawkSynchronizationStartEvent(HawkSynchronizationStartEvent other) {
    __isset_bitfield = other.__isset_bitfield;
    this.timestampNanos = other.timestampNanos;
  }

  public HawkSynchronizationStartEvent deepCopy() {
    return new HawkSynchronizationStartEvent(this);
  }

  @Override
  public void clear() {
    setTimestampNanosIsSet(false);
    this.timestampNanos = 0;
  }

  public long getTimestampNanos() {
    return this.timestampNanos;
  }

  public HawkSynchronizationStartEvent setTimestampNanos(long timestampNanos) {
    this.timestampNanos = timestampNanos;
    setTimestampNanosIsSet(true);
    return this;
  }

  public void unsetTimestampNanos() {
    __isset_bitfield = org.apache.thrift.EncodingUtils.clearBit(__isset_bitfield, __TIMESTAMPNANOS_ISSET_ID);
  }

  /** Returns true if field timestampNanos is set (has been assigned a value) and false otherwise */
  public boolean isSetTimestampNanos() {
    return org.apache.thrift.EncodingUtils.testBit(__isset_bitfield, __TIMESTAMPNANOS_ISSET_ID);
  }

  public void setTimestampNanosIsSet(boolean value) {
    __isset_bitfield = org.apache.thrift.EncodingUtils.setBit(__isset_bitfield, __TIMESTAMPNANOS_ISSET_ID, value);
  }

  public void setFieldValue(_Fields field, @org.apache.thrift.annotation.Nullable java.lang.Object value) {
    switch (field) {
    case TIMESTAMP_NANOS:
      if (value == null) {
        unsetTimestampNanos();
      } else {
        setTimestampNanos((java.lang.Long)value);
      }
      break;

    }
  }

  @org.apache.thrift.annotation.Nullable
  public java.lang.Object getFieldValue(_Fields field) {
    switch (field) {
    case TIMESTAMP_NANOS:
      return getTimestampNanos();

    }
    throw new java.lang.IllegalStateException();
  }

  /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
  public boolean isSet(_Fields field) {
    if (field == null) {
      throw new java.lang.IllegalArgumentException();
    }

    switch (field) {
    case TIMESTAMP_NANOS:
      return isSetTimestampNanos();
    }
    throw new java.lang.IllegalStateException();
  }

  @Override
  public boolean equals(java.lang.Object that) {
    if (that == null)
      return false;
    if (that instanceof HawkSynchronizationStartEvent)
      return this.equals((HawkSynchronizationStartEvent)that);
    return false;
  }

  public boolean equals(HawkSynchronizationStartEvent that) {
    if (that == null)
      return false;
    if (this == that)
      return true;

    boolean this_present_timestampNanos = true;
    boolean that_present_timestampNanos = true;
    if (this_present_timestampNanos || that_present_timestampNanos) {
      if (!(this_present_timestampNanos && that_present_timestampNanos))
        return false;
      if (this.timestampNanos != that.timestampNanos)
        return false;
    }

    return true;
  }

  @Override
  public int hashCode() {
    int hashCode = 1;

    hashCode = hashCode * 8191 + org.apache.thrift.TBaseHelper.hashCode(timestampNanos);

    return hashCode;
  }

  @Override
  public int compareTo(HawkSynchronizationStartEvent other) {
    if (!getClass().equals(other.getClass())) {
      return getClass().getName().compareTo(other.getClass().getName());
    }

    int lastComparison = 0;

    lastComparison = java.lang.Boolean.valueOf(isSetTimestampNanos()).compareTo(other.isSetTimestampNanos());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetTimestampNanos()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.timestampNanos, other.timestampNanos);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    return 0;
  }

  @org.apache.thrift.annotation.Nullable
  public _Fields fieldForId(int fieldId) {
    return _Fields.findByThriftId(fieldId);
  }

  public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
    scheme(iprot).read(iprot, this);
  }

  public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
    scheme(oprot).write(oprot, this);
  }

  @Override
  public java.lang.String toString() {
    java.lang.StringBuilder sb = new java.lang.StringBuilder("HawkSynchronizationStartEvent(");
    boolean first = true;

    sb.append("timestampNanos:");
    sb.append(this.timestampNanos);
    first = false;
    sb.append(")");
    return sb.toString();
  }

  public void validate() throws org.apache.thrift.TException {
    // check for required fields
    // alas, we cannot check 'timestampNanos' because it's a primitive and you chose the non-beans generator.
    // check for sub-struct validity
  }

  private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
    try {
      write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
    } catch (org.apache.thrift.TException te) {
      throw new java.io.IOException(te);
    }
  }

  private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, java.lang.ClassNotFoundException {
    try {
      // it doesn't seem like you should have to do this, but java serialization is wacky, and doesn't call the default constructor.
      __isset_bitfield = 0;
      read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
    } catch (org.apache.thrift.TException te) {
      throw new java.io.IOException(te);
    }
  }

  private static class HawkSynchronizationStartEventStandardSchemeFactory implements org.apache.thrift.scheme.SchemeFactory {
    public HawkSynchronizationStartEventStandardScheme getScheme() {
      return new HawkSynchronizationStartEventStandardScheme();
    }
  }

  private static class HawkSynchronizationStartEventStandardScheme extends org.apache.thrift.scheme.StandardScheme<HawkSynchronizationStartEvent> {

    public void read(org.apache.thrift.protocol.TProtocol iprot, HawkSynchronizationStartEvent struct) throws org.apache.thrift.TException {
      org.apache.thrift.protocol.TField schemeField;
      iprot.readStructBegin();
      while (true)
      {
        schemeField = iprot.readFieldBegin();
        if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
          break;
        }
        switch (schemeField.id) {
          case 1: // TIMESTAMP_NANOS
            if (schemeField.type == org.apache.thrift.protocol.TType.I64) {
              struct.timestampNanos = iprot.readI64();
              struct.setTimestampNanosIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          default:
            org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();

      // check for required fields of primitive type, which can't be checked in the validate method
      if (!struct.isSetTimestampNanos()) {
        throw new org.apache.thrift.protocol.TProtocolException("Required field 'timestampNanos' was not found in serialized data! Struct: " + toString());
      }
      struct.validate();
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot, HawkSynchronizationStartEvent struct) throws org.apache.thrift.TException {
      struct.validate();

      oprot.writeStructBegin(STRUCT_DESC);
      oprot.writeFieldBegin(TIMESTAMP_NANOS_FIELD_DESC);
      oprot.writeI64(struct.timestampNanos);
      oprot.writeFieldEnd();
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

  }

  private static class HawkSynchronizationStartEventTupleSchemeFactory implements org.apache.thrift.scheme.SchemeFactory {
    public HawkSynchronizationStartEventTupleScheme getScheme() {
      return new HawkSynchronizationStartEventTupleScheme();
    }
  }

  private static class HawkSynchronizationStartEventTupleScheme extends org.apache.thrift.scheme.TupleScheme<HawkSynchronizationStartEvent> {

    @Override
    public void write(org.apache.thrift.protocol.TProtocol prot, HawkSynchronizationStartEvent struct) throws org.apache.thrift.TException {
      org.apache.thrift.protocol.TTupleProtocol oprot = (org.apache.thrift.protocol.TTupleProtocol) prot;
      oprot.writeI64(struct.timestampNanos);
    }

    @Override
    public void read(org.apache.thrift.protocol.TProtocol prot, HawkSynchronizationStartEvent struct) throws org.apache.thrift.TException {
      org.apache.thrift.protocol.TTupleProtocol iprot = (org.apache.thrift.protocol.TTupleProtocol) prot;
      struct.timestampNanos = iprot.readI64();
      struct.setTimestampNanosIsSet(true);
    }
  }

  private static <S extends org.apache.thrift.scheme.IScheme> S scheme(org.apache.thrift.protocol.TProtocol proto) {
    return (org.apache.thrift.scheme.StandardScheme.class.equals(proto.getScheme()) ? STANDARD_SCHEME_FACTORY : TUPLE_SCHEME_FACTORY).getScheme();
  }
}

